(******************************************************************************)
(* OASIS: architecture for building OCaml libraries and applications          *)
(*                                                                            *)
(* Copyright (C) 2008-2010, OCamlCore SARL                                    *)
(*                                                                            *)
(* This library is free software; you can redistribute it and/or modify it    *)
(* under the terms of the GNU Lesser General Public License as published by   *)
(* the Free Software Foundation; either version 2.1 of the License, or (at    *)
(* your option) any later version, with the OCaml static compilation          *)
(* exception.                                                                 *)
(*                                                                            *)
(* This library is distributed in the hope that it will be useful, but        *)
(* WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY *)
(* or FITNESS FOR A PARTICULAR PURPOSE. See the file COPYING for more         *)
(* details.                                                                   *)
(*                                                                            *)
(* You should have received a copy of the GNU Lesser General Public License   *)
(* along with this library; if not, write to the Free Software Foundation,    *)
(* Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA              *)
(******************************************************************************)

open OASISUtils
open OASISGettext

let parse argv args =
    (* Simulate command line for Arg *)
    let current =
      ref 0
    in

      try
        Arg.parse_argv
          ~current:current
          (Array.concat [[|"none"|]; argv])
          (Arg.align args)
          (failwithf (f_ "Don't know what to do with arguments: '%s'"))
          (s_ "configure options:")
      with
        | Arg.Help txt ->
            print_endline txt;
            exit 0
        | Arg.Bad txt ->
            prerr_endline txt;
            exit 1
